/* This file was automatically generated.  Do not edit! */
typedef struct hub hub;
struct hub {
  gboolean adc;            // TRUE = ADC, FALSE = NMDC protocol.
  int state;               // (ADC) ADC_S_*
  struct ui_tab *tab;
  struct net *net;

  // Hub info / config
  guint64 id;              // "hubid" number
  char *hubname;           // UTF-8, or NULL when unknown
  char *hubname_hub;       // (NMDC) in hub encoding

  // Our user info
  char *nick_hub;          // (NMDC) in hub encoding
  char *nick;              // UTF-8
  int sid;                 // (ADC) session ID
  gboolean nick_valid : 1; // TRUE is the above nick has also been validated (and we're properly logged in)
  gboolean isreg : 1;      // whether we used a password to login
  gboolean isop : 1;       // whether we're an OP or not

  // User list information
  int sharecount;
  guint64 sharesize;
  GHashTable *users;       // key = username (in hub encoding for NMDC)
  GHashTable *sessions;    // (ADC) key = sid

  // (NMDC) what we and the hub support
  gboolean supports_nogetinfo;

  // Timers
  guint nfo_timer;         // hub_send_nfo() timer
  guint reconnect_timer;   // reconnect timer (30 sec.)

  // ADC login info
  char *gpa_salt;
  int gpa_salt_len;

#if TLS_SUPPORT
  // TLS certificate verification
  char *kp;                // NULL if it matches config, 32 bytes slice-alloced otherwise
#endif

  // last info we sent to the hub
  char *nfo_desc, *nfo_conn, *nfo_mail;
  unsigned char nfo_slots, nfo_h_norm, nfo_h_reg, nfo_h_op;
  guint64 nfo_share;
  guint32 nfo_ip4;
  unsigned short nfo_port;
  gboolean nfo_sup_tls;

  // userlist fetching detection
  gboolean received_first;  // true if one precondition for joincomplete is satisfied.
  gboolean joincomplete;    // if we have the userlist
  guint joincomplete_timer; // fallback timer which ensures joincomplete is set at some point
};
void hub_free(struct hub *hub);
struct hub *hub_create(struct ui_tab *tab);
void hub_connect(struct hub *hub);
void hub_disconnect(struct hub *hub,gboolean recon);
typedef struct hub_user hub_user;
void hub_msg(struct hub *hub,struct hub_user *user,const char *str,gboolean me,int dest);
void hub_say(struct hub *hub,const char *str,gboolean me);
void hub_search(struct hub *hub,struct search_q *q);
void hub_opencc(struct hub *hub,struct hub_user *u);
void hub_kick(struct hub *hub,struct hub_user *u);
void hub_password(struct hub *hub,char *pass);
void hub_send_nfo(struct hub *hub);
void hub_global_nfochange();
char *hub_user_tag(struct hub_user *u);
#define hub_user_conn(u) (!(u)->conn ? NULL :\
  (u)->hub->adc ? g_strdup_printf("%d KiB/s", GPOINTER_TO_UINT((u)->conn)/1024) : g_strdup((u)->conn))
void hub_user_suggest(struct hub *hub,char *str,char **sug);
struct hub_user *hub_user_get(struct hub *hub,const char *name);
extern GHashTable *hub_uids;
#define hub_init_global() hub_uids = g_hash_table_new(g_int64_hash, g_int64_equal)
struct hub_user {
  gboolean hasinfo : 1;
  gboolean isop : 1;
  gboolean isjoined : 1; // managed by ui_hub_userchange()
  gboolean active : 1;
  gboolean hasudp4 : 1;
  gboolean hastls : 1;   // NMDC: 0x10 flag in $MyINFO; ADC: SU has ADCS or ADC0
  gboolean hasadc0 : 1;  // (ADC) Whether the SU flag was ADC0 (otherwise it was ADCS)
  unsigned char h_norm;
  unsigned char h_reg;
  unsigned char h_op;
  unsigned char slots;
  unsigned short udp4;
  unsigned int as;       // auto-open slot if upload is below n bytes/s
  guint32 ip4;
  int sid;        // for ADC
  struct hub *hub;
  char *name;     // UTF-8
  char *name_hub; // hub-encoded (NMDC)
  char *desc;
  char *conn;     // NMDC: string pointer, ADC: GUINT_TO_POINTER() of the US param
  char *mail;
  char *client;
  char cid[8];   // for ADC - only the first 8 bytes of the CID, for simple verification purposes
  guint64 uid;
  guint64 sharesize;
#if TLS_SUPPORT
  char *kp;      // ADC with KEYP, 32 bytes slice-alloc'ed
#endif
  GSequenceIter *iter; // used by ui_userlist_*
};
#define INTERFACE 0
